import java.io.*;

import dk.vajhoej.record.*;
import dk.vajhoej.isam.*;
import dk.vajhoej.isam.cache.*;
import dk.vajhoej.isam.local.*;
import dk.vajhoej.isam.remote.*;

public class Test3 {
    public static void list(IsamSource isam) throws IsamException, RecordException {
        IsamResult<Data3> res = isam.readGT(Data3.class, new Key<Integer>(0, 0));
        while(res.read()) {
            Data3 o = res.current();
            System.out.println(o.getId() + " " + o.getClass().getName() + " " + o);
        }
        res.close();
    }
    public static void add(IsamSource isam) throws IsamException, RecordException {
        Data3B o = new Data3B();
        o.setId(777);
        o.setXv(456.789f);
        isam.create(o);
    }
    public static void remove(IsamSource isam) throws IsamException, RecordException {
        isam.delete(Data3.class, new Key<Integer>(0, 777));
    }
    public static void test(IsamSource isam) throws IsamException, RecordException {
        list(isam);
        add(isam);
        list(isam);
        remove(isam);
        list(isam);
    }
    public static void main(String[] args) {
        try {
            System.out.println("**** multiple structs with tag field ****");
            System.out.println("local");
            System.out.println("=====");
            IsamSource local = new LocalIsamSource("data3.isq", "dk.vajhoej.vms.rms.IndexSequential", false);
            test(local);
            local.close();
            if(args.length > 0 && args[0].toLowerCase().equals("noremote")) System.exit(0);
            System.out.print("Start server and press return...");
            System.in.read();
            System.out.println("remote");
            System.out.println("======");
            IsamSource remote = new RemoteIsamSource("localhost", 10003);
            test(remote);
            remote.close();
        } catch(Exception ex) {
            ex.printStackTrace();
        }
    }
}
