import java.io.*;
import java.util.*;

import dk.vajhoej.record.*;
import dk.vajhoej.isam.*;
import dk.vajhoej.isam.cache.*;
import dk.vajhoej.isam.local.*;
import dk.vajhoej.isam.remote.*;

public class Test4 {
    public static void list(IsamSource isam) throws IsamException, RecordException {
        IsamResult<Data4> res = isam.readGE(Data4.class, new Key0<Integer>(0));
        while(res.read()) {
            Data4 o = res.current();
            System.out.println(o.getId() + " = |" + o.getVal() + "|");
        }
        res.close();
    }
    public static void test(IsamSource isam) throws IsamException, RecordException {
        list(isam);
    }
    public static void main(String[] args) {
        try {
            System.out.println("**** struct with C string ****");
            System.out.println("local");
            System.out.println("=====");
            IsamSource local = new LocalIsamSource("data4.isq", "dk.vajhoej.vms.rms.IndexSequential", true);
            test(local);
            local.close();
            if(args.length > 0 && args[0].toLowerCase().equals("noremote")) System.exit(0);
            System.out.print("Start server and press return...");
            System.in.read();
            System.out.println("remote (object)");
            System.out.println("===============");
            IsamSource remote = new RemoteIsamSource("localhost", 10004);
            test(remote);
            remote.close();
        } catch(Exception ex) {
            ex.printStackTrace();
        }
    }
}    
